// power_CompareLauncher.h
// "Fake" launcher.  Overwrites a cmpldi instruction with another one, slightly
// different value. 
#ifndef _POWER_COMPARE_LAUNCHER_H_
#define _POWER_COMPARE_LAUNCHER_H_

#include "launcher.h"
#include "instr.h"
#include "kernelDriver.h"

class power_CompareLauncher : public launcher {
 private:
   typedef launcher inherited;

   void doInstallNotOverwritingExisting(bool justTesting,
                                        const regset_t *freeRegs,
                                        kernelDriver &theKernelDriver,
                                        bool verboseTimings);
   void doInstallOverwritingExisting(bool justTesting,
                                     const instr_t *otherGuysCurrInstalledInsn,
                                        // needed for asserting when we poke
                                     const regset_t *freeRegs,
                                     kernelDriver &theKernelDriver,
                                     bool verboseTimings);
   
   void doUninstallNoOtherAlreadyInstalled(bool justTesting,
                                           kernelDriver &theKernelDriver,
                                           bool verboseTimings);

   void doUninstallAnotherAlreadyInstalled(bool justTesting,
                                           kernelDriver &,
                                           bool verboseTimings);
   
   void print_info() const;

   power_CompareLauncher(const power_CompareLauncher &);
   power_CompareLauncher &operator=(const power_CompareLauncher &);
   
 public:
   power_CompareLauncher(kptr_t ifrom, kptr_t ito,
                       const instr_t *iwhenAllDoneRestoreToThisInsn);
  ~power_CompareLauncher() {} // calls base class dtor automatically

   instr_t* createSplicingInsn() const;
};

#endif
